// ****************************************************************************
//  vfd.c                           (C) 1992-2003 Christophe de Dinechin (ddd) 
//                                                            VFD800 project 
// ****************************************************************************
// 
//   File Description:
// 
//    Control functions for the VFD800 (Noritake)
// 
// 
// 
// 
// 
// 
// 
// 
// ****************************************************************************
// This document is confidential.
// Do not redistribute without written permission
// ****************************************************************************
// * File       : $RCSFile$
// * Revision   : $Revision$
// * Date       : $Date$
// ****************************************************************************

#include "vfd.h"
#include <time.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/io.h>



// ============================================================================
// 
//   High-level functions
// 
// ============================================================================

int VFD_Init()
// ----------------------------------------------------------------------------
//   Initialize the VFD
// ----------------------------------------------------------------------------
{
    int error = 0;
    int n;

   if (ioperm(CONTROLPORT,1,1))
   {
       fprintf(stderr, "Couldn't get the port at %x\n", CONTROLPORT);
       return 1;
   }
   if (ioperm(DATAPORT,1,1))
   {
      fprintf(stderr, "Couldn't get the port at %x\n", DATAPORT);
      return 1;
   };

    // Start 800 init sequence
    VFD_Command (INIT800A);
    usleep (2 MS);

    for(n=0;n<8;n++)
    {
        VFD_Command(INIT800B);
        usleep (2 MS);
        VFD_Command(INIT800C(n));
        usleep (2 MS);
        VFD_Data(INIT800D);
        usleep (2 MS);
    }

    // Initialize for us
    VFD_EnableScreen(1, 1);     // Enable both screens
    VFD_Command(ORON);          // OR both screens
    VFD_Command(HSHIFT);        // Set horizontal shift
    VFD_Command(0);             // = 0
    VFD_Command(VSHIFT);        // Set vertical shift

    VFD_Command(AUTOINCX);      // Auto-increment X by default
    VFD_Command(SETX);          // Set X coordinate
    VFD_Command(0x0);           // to 0
    VFD_Command(SETY);          // Set Y coordinate
    VFD_Command(0);             // to 0

    return 0;
}


void VFD_EnableScreen(int screen0, int screen1)
// ----------------------------------------------------------------------------
//   Enable the given screen layers
// ----------------------------------------------------------------------------
{
    int command = 0x20 | ((screen0<<2) + (screen1<<3));
    VFD_Command(command);
    VFD_Brightness(1.0);
}


void VFD_Brightness(float brightness)
// ----------------------------------------------------------------------------
//   Select the brightness
// ----------------------------------------------------------------------------
{
    if (brightness > 1.0)
        brightness = 1.0;
    if (brightness < 0.0)
        brightness = 0.0;

    VFD_Command(0x40 | (15 - (int) (15 * brightness)));
}


void VFD_SetX(int X)
// ----------------------------------------------------------------------------
//   Move cursor on X axis
// ----------------------------------------------------------------------------
{
    VFD_Command(SETX);
    VFD_Command(X);
}


void VFD_SetY(int Y)
// ----------------------------------------------------------------------------
//   Move cursor on X axis
// ----------------------------------------------------------------------------
{
    VFD_Command(SETY);
    VFD_Command(Y);
}


void VFD_SetXY(int X, int Y)
// ----------------------------------------------------------------------------
//   Move cursor on X axis
// ----------------------------------------------------------------------------
{
    VFD_SetX(X); VFD_SetY(Y);
}


void VFD_Char(char c)
// ----------------------------------------------------------------------------
//    Emit a single character
// ----------------------------------------------------------------------------
{
    char *ptr = VFD_Font[(unsigned char) c];
    int col;
    for (col = 0; col < 6; col++)
        VFD_Data(*ptr++);
}


void VFD_Text(char *text)
// ----------------------------------------------------------------------------
//   Emit the text at current position
// ----------------------------------------------------------------------------
{
    char c;
    while (c = *text++)
        VFD_Char(c);
}



// ============================================================================
// 
//    Low-level functions
// 
// ============================================================================

void VFD_Command(int command)
// ----------------------------------------------------------------------------
//   Send the given command to the VFD
// ----------------------------------------------------------------------------
{
    // Set C/D to C (control)
    // outb(0x0, CONTROLPORT);

    // Write data port
    outb(command, DATAPORT);

    // Set /WR
    outb (0x01, CONTROLPORT);

    // Reset /WR
    outb (0x00, CONTROLPORT);
}


void VFD_Data(int data)
// ----------------------------------------------------------------------------
//   Send the given command to the VFD
// ----------------------------------------------------------------------------
{
    // Set C/D to D (data)
    // outb(0x08, CONTROLPORT);

    // Write data port
    outb(data, DATAPORT);

    // Set /WR
    outb (0x09, CONTROLPORT);

    // Reset /WR
    outb (0x08, CONTROLPORT);
}



char VFD_Font[256][6] =
// ----------------------------------------------------------------------------
//   The default ASCII charset for the VFD
// ----------------------------------------------------------------------------
{
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x00   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x01   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x02   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x03   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x04   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x05   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x06   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x07   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x08   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x09   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x0A   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x0B   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x0C   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x0D   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x0E   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x0F   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x10   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x11   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x12   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x13   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x14   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x15   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x16   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x17   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x18   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x19   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x1A   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x1B   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x1C   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x1D   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x1E   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x1F   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x20   */
{ 0x00, 0x00, 0x5E, 0x00, 0x00, 0x00 }, /* 0x21 ! */
{ 0x00, 0x0E, 0x00, 0x0E, 0x00, 0x00 }, /* 0x22 " */
{ 0x14, 0x7F, 0x14, 0x7F, 0x14, 0x00 }, /* 0x23 # */
{ 0x24, 0x2A, 0x7F, 0x2A, 0x12, 0x00 }, /* 0x24 $ */
{ 0x46, 0x26, 0x10, 0x68, 0x64, 0x00 }, /* 0x25 % */
{ 0x36, 0x49, 0x55, 0x22, 0x50, 0x00 }, /* 0x26 & */
{ 0x00, 0x0A, 0x06, 0x00, 0x00, 0x00 }, /* 0x27 ' */
{ 0x00, 0x1C, 0x22, 0x41, 0x00, 0x00 }, /* 0x28 ( */
{ 0x00, 0x00, 0x41, 0x22, 0x1C, 0x00 }, /* 0x29 ) */
{ 0x28, 0x10, 0x7C, 0x10, 0x28, 0x00 }, /* 0x2A * */
{ 0x08, 0x08, 0x3E, 0x08, 0x08, 0x00 }, /* 0x2B + */
{ 0x00, 0x00, 0x50, 0x30, 0x00, 0x00 }, /* 0x2C , */
{ 0x08, 0x08, 0x08, 0x08, 0x08, 0x00 }, /* 0x2D - */
{ 0x00, 0x60, 0x60, 0x00, 0x00, 0x00 }, /* 0x2E . */
{ 0x40, 0x20, 0x10, 0x08, 0x04, 0x00 }, /* 0x2F / */
{ 0x3E, 0x51, 0x49, 0x45, 0x3E, 0x00 }, /* 0x30 0 */
{ 0x00, 0x42, 0x7F, 0x40, 0x00, 0x00 }, /* 0x31 1 */
{ 0x42, 0x61, 0x51, 0x49, 0x46, 0x00 }, /* 0x32 2 */
{ 0x21, 0x41, 0x45, 0x4B, 0x31, 0x00 }, /* 0x33 3 */
{ 0x18, 0x14, 0x12, 0x7F, 0x10, 0x00 }, /* 0x34 4 */
{ 0x27, 0x45, 0x45, 0x45, 0x39, 0x00 }, /* 0x35 5 */
{ 0x3C, 0x4A, 0x49, 0x49, 0x30, 0x00 }, /* 0x36 6 */
{ 0x01, 0x71, 0x09, 0x05, 0x03, 0x00 }, /* 0x37 7 */
{ 0x36, 0x49, 0x49, 0x49, 0x36, 0x00 }, /* 0x38 8 */
{ 0x06, 0x49, 0x49, 0x29, 0x1E, 0x00 }, /* 0x39 9 */
{ 0x00, 0x36, 0x36, 0x00, 0x00, 0x00 }, /* 0x3A : */
{ 0x00, 0x56, 0x36, 0x00, 0x00, 0x00 }, /* 0x3B ; */
{ 0x08, 0x14, 0x22, 0x41, 0x00, 0x00 }, /* 0x3C < */
{ 0x14, 0x14, 0x14, 0x14, 0x14, 0x00 }, /* 0x3D = */
{ 0x00, 0x41, 0x22, 0x14, 0x08, 0x00 }, /* 0x3E > */
{ 0x02, 0x01, 0x51, 0x09, 0x06, 0x00 }, /* 0x3F ? */
{ 0x32, 0x49, 0x79, 0x41, 0x3E, 0x00 }, /* 0x40 @ */
{ 0x7E, 0x11, 0x11, 0x11, 0x7E, 0x00 }, /* 0x41 A */
{ 0x7F, 0x49, 0x49, 0x49, 0x36, 0x00 }, /* 0x42 B */
{ 0x3E, 0x41, 0x41, 0x41, 0x22, 0x00 }, /* 0x43 C */
{ 0x7F, 0x41, 0x41, 0x22, 0x1C, 0x00 }, /* 0x44 D */
{ 0x7F, 0x49, 0x49, 0x49, 0x41, 0x00 }, /* 0x45 E */
{ 0x7F, 0x09, 0x09, 0x09, 0x01, 0x00 }, /* 0x46 F */
{ 0x3E, 0x41, 0x49, 0x49, 0x7A, 0x00 }, /* 0x47 G */
{ 0x7F, 0x08, 0x08, 0x08, 0x7F, 0x00 }, /* 0x48 H */
{ 0x00, 0x41, 0x7F, 0x41, 0x00, 0x00 }, /* 0x49 I */
{ 0x20, 0x40, 0x41, 0x3F, 0x01, 0x00 }, /* 0x4A J */
{ 0x7F, 0x08, 0x14, 0x22, 0x41, 0x00 }, /* 0x4B K */
{ 0x7F, 0x40, 0x40, 0x40, 0x40, 0x00 }, /* 0x4C L */
{ 0x7F, 0x02, 0x0C, 0x02, 0x7F, 0x00 }, /* 0x4D M */
{ 0x7F, 0x04, 0x08, 0x10, 0x7F, 0x00 }, /* 0x4E N */
{ 0x3E, 0x41, 0x41, 0x41, 0x3E, 0x00 }, /* 0x4F O */
{ 0x7F, 0x09, 0x09, 0x09, 0x06, 0x00 }, /* 0x50 P */
{ 0x3E, 0x41, 0x51, 0x21, 0x5E, 0x00 }, /* 0x51 Q */
{ 0x7F, 0x09, 0x19, 0x29, 0x46, 0x00 }, /* 0x52 R */
{ 0x46, 0x49, 0x49, 0x49, 0x31, 0x00 }, /* 0x53 S */
{ 0x01, 0x01, 0x7F, 0x01, 0x01, 0x00 }, /* 0x54 T */
{ 0x3F, 0x40, 0x40, 0x40, 0x3F, 0x00 }, /* 0x55 U */
{ 0x1F, 0x20, 0x40, 0x20, 0x1F, 0x00 }, /* 0x56 V */
{ 0x3F, 0x40, 0x30, 0x40, 0x3F, 0x00 }, /* 0x57 W */
{ 0x63, 0x14, 0x08, 0x14, 0x63, 0x00 }, /* 0x58 X */
{ 0x07, 0x08, 0x70, 0x08, 0x07, 0x00 }, /* 0x59 Y */
{ 0x61, 0x51, 0x49, 0x45, 0x43, 0x00 }, /* 0x5A Z */
{ 0x7F, 0x41, 0x41, 0x00, 0x00, 0x00 }, /* 0x5B [ */
{ 0x02, 0x04, 0x08, 0x10, 0x20, 0x00 }, /* 0x5C \ */
{ 0x00, 0x00, 0x41, 0x41, 0x7F, 0x00 }, /* 0x5D ] */
{ 0x04, 0x02, 0x01, 0x02, 0x04, 0x00 }, /* 0x5E ^ */
{ 0x40, 0x40, 0x40, 0x40, 0x40, 0x00 }, /* 0x5F _ */
{ 0x00, 0x01, 0x02, 0x04, 0x00, 0x00 }, /* 0x60 ` */
{ 0x20, 0x54, 0x54, 0x54, 0x78, 0x00 }, /* 0x61 a */
{ 0x7F, 0x44, 0x44, 0x44, 0x38, 0x00 }, /* 0x62 b */
{ 0x38, 0x44, 0x44, 0x44, 0x44, 0x00 }, /* 0x63 c */
{ 0x38, 0x44, 0x44, 0x44, 0x7F, 0x00 }, /* 0x64 d */
{ 0x38, 0x54, 0x54, 0x54, 0x58, 0x00 }, /* 0x65 e */
{ 0x08, 0x7E, 0x09, 0x09, 0x02, 0x00 }, /* 0x66 f */
{ 0x18, 0xA4, 0xA4, 0xA4, 0x7C, 0x00 }, /* 0x67 g */
{ 0x7F, 0x04, 0x04, 0x04, 0x78, 0x00 }, /* 0x68 h */
{ 0x00, 0x44, 0x7D, 0x40, 0x00, 0x00 }, /* 0x69 i */
{ 0x20, 0x40, 0x40, 0x3D, 0x00, 0x00 }, /* 0x6A j */
{ 0x00, 0x7F, 0x10, 0x28, 0x44, 0x00 }, /* 0x6B k */
{ 0x00, 0x00, 0x41, 0x7F, 0x40, 0x00 }, /* 0x6C l */
{ 0x7C, 0x04, 0x38, 0x04, 0x78, 0x00 }, /* 0x6D m */
{ 0x7C, 0x08, 0x04, 0x04, 0x78, 0x00 }, /* 0x6E n */
{ 0x38, 0x44, 0x44, 0x44, 0x38, 0x00 }, /* 0x6F o */
{ 0xFC, 0x24, 0x24, 0x24, 0x18, 0x00 }, /* 0x70 p */
{ 0x18, 0x24, 0x24, 0x24, 0xFC, 0x00 }, /* 0x71 q */
{ 0x7C, 0x08, 0x04, 0x04, 0x08, 0x00 }, /* 0x72 r */
{ 0x48, 0x54, 0x54, 0x54, 0x24, 0x00 }, /* 0x73 s */
{ 0x04, 0x3F, 0x44, 0x44, 0x20, 0x00 }, /* 0x74 t */
{ 0x3C, 0x40, 0x40, 0x40, 0x3C, 0x00 }, /* 0x75 u */
{ 0x1C, 0x20, 0x40, 0x20, 0x1C, 0x00 }, /* 0x76 v */
{ 0x3C, 0x40, 0x30, 0x40, 0x3C, 0x00 }, /* 0x77 w */
{ 0x44, 0x28, 0x10, 0x28, 0x44, 0x00 }, /* 0x78 x */
{ 0x1C, 0xA0, 0xA0, 0xA0, 0x7C, 0x00 }, /* 0x79 y */
{ 0x44, 0x64, 0x54, 0x4C, 0x44, 0x00 }, /* 0x7A z */
{ 0x08, 0x36, 0x41, 0x41, 0x00, 0x00 }, /* 0x7B { */
{ 0x00, 0x00, 0x77, 0x00, 0x00, 0x00 }, /* 0x7C | */
{ 0x00, 0x41, 0x41, 0x36, 0x08, 0x00 }, /* 0x7D } */
{ 0x08, 0x04, 0x04, 0x04, 0x02, 0x00 }, /* 0x7E ~ */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x7F   */
{ 0x40, 0x40, 0x40, 0x40, 0x40, 0x00 }, /* 0x80   */
{ 0x60, 0x60, 0x60, 0x60, 0x60, 0x00 }, /* 0x81   */
{ 0x70, 0x70, 0x70, 0x70, 0x70, 0x00 }, /* 0x82   */
{ 0x78, 0x78, 0x78, 0x78, 0x78, 0x00 }, /* 0x83   */
{ 0x7C, 0x7C, 0x7C, 0x7C, 0x7C, 0x00 }, /* 0x84   */
{ 0x7E, 0x7E, 0x7E, 0x7E, 0x7E, 0x00 }, /* 0x85   */
{ 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x00 }, /* 0x86   */
{ 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00 }, /* 0x87   */
{ 0x7F, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0x88   */
{ 0x7F, 0x7F, 0x00, 0x00, 0x00, 0x00 }, /* 0x89   */
{ 0x7F, 0x7F, 0x7F, 0x00, 0x00, 0x00 }, /* 0x8A   */
{ 0x7F, 0x7F, 0x7F, 0x7F, 0x00, 0x00 }, /* 0x8B   */
{ 0x7F, 0x7F, 0x7F, 0x7F, 0x7F, 0x00 }, /* 0x8C   */
{ 0x55, 0x2A, 0x55, 0x2A, 0x55, 0x00 }, /* 0x8D   */
{ 0xAA, 0x55, 0xAA, 0x55, 0xAA, 0x55 }, /* 0x8E   */
{ 0x10, 0x10, 0x10, 0xFF, 0x10, 0x10 }, /* 0x8F   */
{ 0x10, 0x10, 0x10, 0x1F, 0x10, 0x10 }, /* 0x90   */
{ 0x10, 0x10, 0x10, 0xF8, 0x10, 0x10 }, /* 0x91   */
{ 0x10, 0x10, 0x10, 0xFF, 0x00, 0x00 }, /* 0x92   */
{ 0x00, 0x00, 0x00, 0xFF, 0x10, 0x10 }, /* 0x93   */
{ 0x01, 0x01, 0x01, 0x01, 0x01, 0x01 }, /* 0x94   */
{ 0x10, 0x10, 0x10, 0x10, 0x10, 0x10 }, /* 0x95   */
{ 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00 }, /* 0x96   */
{ 0x00, 0x00, 0x00, 0xF0, 0x10, 0x10 }, /* 0x97   */
{ 0x10, 0x10, 0x10, 0xF0, 0x00, 0x00 }, /* 0x98   */
{ 0x00, 0x00, 0x00, 0x1F, 0x10, 0x10 }, /* 0x99   */
{ 0x10, 0x10, 0x10, 0x1F, 0x00, 0x00 }, /* 0x9A   */
{ 0x00, 0x00, 0x00, 0xE0, 0x10, 0x10 }, /* 0x9B   */
{ 0x10, 0x10, 0x20, 0xC0, 0x00, 0x00 }, /* 0x9C   */
{ 0x00, 0x00, 0x00, 0x0F, 0x10, 0x10 }, /* 0x9D   */
{ 0x20, 0x20, 0x10, 0x0F, 0x00, 0x00 }, /* 0x9E   */
{ 0x78, 0x15, 0x14, 0x15, 0x78, 0x00 }, /* 0x9F   */
{ 0x78, 0x14, 0x15, 0x14, 0x78, 0x00 }, /* 0xA0   */
{ 0x78, 0x14, 0x16, 0x15, 0x78, 0x00 }, /* 0xA1   */
{ 0x0E, 0x51, 0x31, 0x11, 0x11, 0x00 }, /* 0xA2   */
{ 0x78, 0x16, 0x15, 0x16, 0x78, 0x00 }, /* 0xA3   */
{ 0x7E, 0x09, 0x7E, 0x4A, 0x4A, 0x00 }, /* 0xA4   */
{ 0x7C, 0x54, 0x56, 0x55, 0x44, 0x00 }, /* 0xA5   */
{ 0x7C, 0x55, 0x56, 0x54, 0x44, 0x00 }, /* 0xA6   */
{ 0x7C, 0x56, 0x55, 0x56, 0x44, 0x00 }, /* 0xA7   */
{ 0x00, 0x45, 0x7C, 0x45, 0x00, 0x00 }, /* 0xA8   */
{ 0x00, 0x44, 0x7E, 0x45, 0x00, 0x00 }, /* 0xA9   */
{ 0x00, 0x45, 0x7E, 0x44, 0x00, 0x00 }, /* 0xAA   */
{ 0x00, 0x46, 0x7D, 0x46, 0x00, 0x00 }, /* 0xAB   */
{ 0x38, 0x45, 0x44, 0x45, 0x38, 0x00 }, /* 0xAC   */
{ 0x7A, 0x09, 0x13, 0x22, 0x79, 0x00 }, /* 0xAD   */
{ 0x3E, 0x51, 0x49, 0x45, 0x3E, 0x00 }, /* 0xAE   */
{ 0x38, 0x44, 0x46, 0x45, 0x38, 0x00 }, /* 0xAF   */
{ 0x38, 0x45, 0x46, 0x44, 0x38, 0x00 }, /* 0xB0   */
{ 0x78, 0x15, 0x16, 0x14, 0x78, 0x00 }, /* 0xB1   */
{ 0xFF, 0x01, 0x01, 0x49, 0x36, 0x00 }, /* 0xB2   */
{ 0x7C, 0x55, 0x54, 0x55, 0x44, 0x00 }, /* 0xB3   */
{ 0x3C, 0x41, 0x40, 0x41, 0x3C, 0x00 }, /* 0xB4   */
{ 0x3C, 0x40, 0x42, 0x41, 0x3C, 0x00 }, /* 0xB5   */
{ 0x3C, 0x41, 0x42, 0x40, 0x3C, 0x00 }, /* 0xB6   */
{ 0x3C, 0x42, 0x41, 0x42, 0x3C, 0x00 }, /* 0xB7   */
{ 0x00, 0x02, 0x05, 0x02, 0x00, 0x00 }, /* 0xB8   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xB9   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xBA   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xBB   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xBC   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xBD   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xBE   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xBF   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xC0   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xC1   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xC2   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xC3   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xC4   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xC5   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xC6   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xC7   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xC8   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xC9   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xCA   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xCB   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xCC   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xCD   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xCE   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xCF   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xD0   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xD1   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xD2   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xD3   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xD4   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xD5   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xD6   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xD7   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xD8   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xD9   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xDA   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xDB   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xDC   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xDD   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xDE   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xDF   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xE0   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xE1   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xE2   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xE3   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xE4   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xE5   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xE6   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xE7   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xE8   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xE9   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xEA   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xEB   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xEC   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xED   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xEE   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xEF   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xF0   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xF1   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xF2   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xF3   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xF4   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xF5   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xF6   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xF7   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xF8   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xF9   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xFA   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xFB   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xFC   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xFD   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, /* 0xFE   */
{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }  /* 0xFF   */
};
